// =============================================================================
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2012 - Scilab Enterprises - Antoine ELIAS
//
//  This file is distributed under the same license as the Scilab package.
// =============================================================================
// <-- CLI SHELL MODE -->
//
// <-- Non-regression test for bug 11538 -->
//
// <-- Bugzilla URL -->
// http://bugzilla.scilab.org/11538
//
// <-- Short Description -->
// check failed of to_wide_string function in WideString functions

// The conversion does not fail under Windows do we can not check that we have an error
if getos() <> "Windows" then
    ilib_verbose(0);
    test_path = get_absolute_file_path('bug_11538.tst');
    currentpath = pwd();
    cd TMPDIR;
    mkdir('bug_11538');
    cd('bug_11538');
    copyfile(SCI+'/modules/api_scilab/tests/nonreg_tests/bug_11538.c' , 'bug_11538.c');
    ilib_build('gw_bug_11538', ['bug_11538', 'sci_bug_11538'], 'bug_11538.c', []);
    exec loader.sce;

    ierr = execstr("bug_11538(""abs"")", "errcatch");
    assert_checktrue(ierr == 0);
    ierr = execstr("bug_11538(ascii(190:210))", "errcatch");
    assert_checkfalse(ierr == 0);
end
